CHANGES IN VERSION 2.4.1
------------------------

- Fix bug in getGeneRegionTrackForGviz that throws an error if both coding and
  non-coding transcripts are fetched.


CHANGES IN VERSION 2.3.14
-------------------------

- New ProteinDomainSourceFilter and ProteinDomainIdFilter.


CHANGES IN VERSION 2.3.11
-------------------------

- Fix for issue #75.


CHANGES IN VERSION 2.3.9
------------------------

- Add transcriptToCds and cdsToTranscript functions (issue #73).


CHANGES IN VERSION 2.3.8
------------------------

- Fix problem creating EnsDb from GTF file lacking exon IDs (issue #72,
  https://support.bioconductor.org/p/105536/).


CHANGES IN VERSION 2.3.7
------------------------

- Switch to EnsDb.Hsapiens.v86 in examples, unit tests and vignettes.


CHANGES IN VERSION 2.3.6
------------------------

BUG FIXES:
    o Fix issue #69 failing to map genomic coordinates to proteins if different
      genomic coordinates are mapped to the same transcripts/proteins.


CHANGES IN VERSION 2.3.5
------------------------

BUG FIXES:
    o Fix problem mapping genomic coordinates on named GRanges.
    

CHANGES IN VERSION 2.3.2
------------------------

NEW FEATURES
    o Functionality to between genomic and transcript-relative or
      protein-relative coordinates: proteinToTranscript, genomeToTranscript,
      transcriptToGenome, transcriptToProtein, genomeToProtein.


CHANGES IN VERSION 2.3.1
------------------------

NEW FEATURES
    o Functionality to map within-protein coordinates to genomic coordinates:
      proteinToGenome function.


CHANGES IN VERSION 2.1.12
------------------------

BUG FIXES:
    o Use new defaults from the IRanges package for arguments maxgap = -1L,
      minoverlap = 0L in transcriptsByOverlaps and exonsByOverlaps methods.

CHANGES IN VERSION 2.1.12
------------------------

BUG FIXES:
    o Remove RSQLite warnings (issue #54).

CHANGES IN VERSION 2.1.11
------------------------

BUG FIXES:
    o ensDbFromGtf failed to parse header for GTF files with more than one
      white space.
      

CHANGES IN VERSION 2.1.10
------------------------

USER VISIBLE CHANGES
     o supportedFilters returns a data frame with the filter class name and
       corresponding field (column) name.


CHANGES IN VERSION 2.1.9
------------------------

NEW FEATURES
    o Support for global filters in an EnsDb object.
    o Add filter function.
    

CHANGES IN VERSION 2.1.8
------------------------

NEW FEATURES
    o New annotations available in EnsDb objects: gene.description and
      tx.tx_support_level.
    o New TxSupportLevelFilter object.


CHANGES IN VERSION 1.99.13
--------------------------

USER VISIBLE CHANGES:
    o Most filter classes are now imported from the AnnotationFilter package.
    o Parameter 'filter' supports now filter expression.
    o Multiple filters can be combined with & and |.
    o buildQuery is no longer exported.


CHANGES IN VERSION 1.99.11
--------------------------

BUG FIXES:
    o ensDbFromGtf failed to fetch sequence length for some ensemblgenomes
      versions.
    

CHANGES IN VERSION 1.99.11
--------------------------

NEW FEATURES
    o Retrieving also the taxonomy ID from the Ensembl databases and storing this
      information into the metadata table.


CHANGES IN VERSION 1.99.10
--------------------------

BUG FIXES:
    o Fix problem on Windows systems failing to download files from Ensembl
      servers.

CHANGES IN VERSION 1.99.6
-------------------------

BUG FIXES:
    o MySQL database name for useMySQL was not created as expected for GTF/GFF
      based EnsDbs.


CHANGES IN VERSION 1.99.5
-------------------------

NEW FEATURES:
    o OnlyCodingTxFilter is now exported. This filter allows to query for
    protein coding genes.


CHANGES IN VERSION 1.99.3
-------------------------

BUG FIXES:
   o Add two additional uniprot table columns to internal variable and fix
     failing unit test.


CHANGES IN VERSION 1.99.3
-------------------------

BUG FIXES:
   o Add two additional uniprot table columns to internal variable and fix
     failing unit test.


CHANGES IN VERSION 1.99.3
-------------------------

NEW FEATURES:
    o UniprotdbFilter and UniprotmappingtypeFilter.

USER VISIBLE CHANGES:
    o Fetching Uniprot database and the type of mapping method for
      Uniprot IDs to Ensembl protein IDs: database columns uniprot_db and
      uniprot_mapping_type.


CHANGES IN VERSION 1.99.2
-------------------------

BUG FIXES:
    o Perl script is no longer failing if no chromosome info is available.


CHANGES IN VERSION 1.99.1
-------------------------

BUG FIXES:
    o No protein table indices were created when inserting an EnsDb with protein
      data to MySQL.


CHANGES IN VERSION 1.99.0
-------------------------

NEW FEATURES:
    o The perl script to create EnsDb databases fetches also protein annotations.
    o Added functionality to extract protein annotations from the database
      (if available) ensuring backward compatibility.
    o Add proteins vignette.

USER VISIBLE CHANGES:
    o Improved functionality to fetch sequence lengths for chromosomes from
      Ensembl or ensemblgenomes.


CHANGES IN VERSION 1.5.14
-------------------------

NEW FEATURES:
    o listEnsDbs function to list EnsDb databases in a MySQL server.
    o EnsDb constructor function allows to directly connect to a EnsDb database
      in a MySQL server.
    o useMySQL compares the creation date between database and SQLite version and
      proposes to update database if different.


CHANGES IN VERSION 1.5.13
-------------------------

NEW FEATURES:
    o useMySQL method to insert the data into a MySQL database and switch backend
      from SQLite to MySQL.


CHANGES IN VERSION 1.5.12
-------------------------

USER VISIBLE CHANGES:
    o Add additional indices on newly created database which improves performance
      considerably.

BUG FIXES
    o Fix issue #11: performance problems with RSQLite 1.0.9011. Ordering for
      cdsBy, transcriptsBy, UTRs by is performed in R and not in SQL.
    o Fix ordering bug: results were sorted by columns in alphabetical order
      (e.g. if order.by = "seq_name, gene_seq_start" was provided they were sorted
      by gene_seq_start and then by seq_name


CHANGES IN VERSION 1.5.11
-------------------------

BUG FIXES
    o makeEnsemblSQLiteFromTables and ensDbFromGRanges perform sanity checks
      on the input tables.


CHANGES IN VERSION 1.5.10
-------------------------

USER VISIBLE CHANGES:
     o Using html_document2 style for the vignette.

CHANGES IN VERSION 1.5.9
-------------------------

NEW FEATURES:
    o New SymbolFilter.
    o returnFilterColumns method to enable/disable that filter columns are also
      returned by the methods (which is the default).
    o select method support for SYMBOL keys, columns and filter.
    o Select method does ensure result ordering matches the input keys if a
      single filter or only keys are provided.


CHANGES IN VERSION 1.5.8
-------------------------

BUG FIXES
    o Fix problem with white space separated species name in ensDbFromGRanges.


CHANGES IN VERSION 1.5.7
-------------------------

OTHER CHANGES
    o Fixed typos in documentation


CHANGES IN VERSION 1.5.6
-------------------------

BUG FIXES
    o Fix warning fo validation of numeric BasicFilter.


CHANGES IN VERSION 1.5.5
-------------------------

BUG FIXES
    o exonsBy: did always return tx_id, even if not present in columns argument.


CHANGES IN VERSION 1.5.4
-------------------------

Bug fixes
    o Column tx_id was always removed from exonsBy result even if in the
      columns argument.
    o exon_idx was of type character if database generated from a GTF file.


CHANGES IN VERSION 1.5.2
-------------------------

BUG FIXES
    o tx_id was removed from metadata columns in txBy.
    o Fixed a bug that caused exon_idx column to be character if database created
      from a GTF.


CHANGES IN VERSION 1.5.1
-------------------------

NEW FEATURES:
    o Added support for column tx_name in all methods and in the keys and select methods.
      Values in the returned tx_name columns correspond to the tx_id.
    o Update documentation.


CHANGES IN VERSION 1.3.20
-------------------------

BUG FIXES
    o methods transcripts, genes etc don't result in an error when columns are specified which
      are not present in the database and the return.type is GRanges.
    o Removed the transcriptLengths method implemented in ensembldb in favor of using the one
      from GenomicFeatures.


CHANGES IN VERSION 1.3.19
-------------------------

BUG FIXES
    o ensDbFromGRanges (and thus ensDbFromGtf, ensDbFromGff and ensDbFromAH) support now
      Ensembl GTF file formats from version 74 and before.


CHANGES IN VERSION 1.3.18
-------------------------

NEW FEATURES
    o New ExonrankFilter to filter based on exon index/rank.


CHANGES IN VERSION 1.3.17
-------------------------

BUG FIXES
    o Use setdiff/intersect instead of psetdiff/pintersect.


CHANGES IN VERSION 1.3.16
-------------------------

BUG FIXES
    o Fixed failing test.


CHANGES IN VERSION 1.3.15
-------------------------

NEW FEATURES
    o GRangesFilter now supports GRanges of length > 1.
    o seqlevels method for GRangesFilter.
    o New methods exonsByOverlaps and transcriptsByOverlaps.


CHANGES IN VERSION 1.3.14
-------------------------

NEW FEATURES
    o seqlevelsStyle getter and setter method to change the enable easier integration
      of EnsDb objects with UCSC based packages. supportedSeqlevelsStyle method to list
      possible values. Global option "ensembldb.seqnameNotFound" allows to adapt the
      behaviour of the mapping functions when a seqname can not be mapped properly.
    o Added a seqlevels method for EnsDb objects.

SIGNIFICANT USER-VISIBLE CHANGES
    o Add an example to extract transcript sequences directly from an EnsDb object to
      the vignette.
    o Add examples to use EnsDb objects with UCSC chromosome names to the vignette.

BUG FIXES
    o Seqinfo for genes, transcripts and exons contain now only the seqnames returned
      in the GRanges, not all that are in the database.


CHANGES IN VERSION 1.3.13
-------------------------

NEW FEATURES
    o EnsDb: new "hidden" slot to store additional properties and a method updateEnsDb
      to update objects to the new implementation.
    o New method "transcriptLengths" for EnsDb that creates a similar data.frame than
      the same named function in the GenomicFeatures package.

BUG FIXES
    o fiveUTRsByTranscript and threeUTRsByTranscript returned wrong UTRs for some special
      cases in which the CDS start and end were in the same exon. This has been fixed.


CHANGES IN VERSION 1.3.12
-------------------------

NEW FEATURES
    o ensDbFromGff and ensDbFromAH functions to build EnsDb objects from GFF3 files
      or directly from AnnotationHub ressources.
    o getGenomeFaFile does now also retrieve Fasta files for the "closest" Ensembl
      release if none is available for the matching version.

SIGNIFICANT USER-VISIBLE CHANGES
    o Removed argument 'verbose' in ensDbFromGRanges and ensDbFromGtf.
    o Updated parts of the vignette.
    o Removed method extractTranscriptSeqs again due to some compatibility problems
      with GenomicRanges.

BUG FIXES
    o Avoid wrong CDS start/end position definition for Ensembl gtf files in which the
      start or end codon is outside the CDS.


CHANGES IN VERSION 1.3.11
-------------------------

BUG FIXES
    o "select" method returns now also the keytype as a column from the database.


CHANGES IN VERSION 1.3.10
-------------------------

NEW FEATURES
    o Implemented methods columns, keys, keytypes, mapIds and select from AnnotationDbi.
    o Methods condition<- and value<- for BasicFilter.


CHANGES IN VERSION 1.3.9
------------------------

SIGNIFICANT USER-VISIBLE CHANGES
    o The shiny app now allows to return the search results.



CHANGES IN VERSION 1.3.7
------------------------

SIGNIFICANT USER-VISIBLE CHANGES
    o Some small changes to the vignette.

BUG FIXES
    o Fixed a problem in an unit test.


CHANGES IN VERSION 1.3.6
------------------------

BUG FIXES
    o Fixed a bug in ensDbFromGRanges.


CHANGES IN VERSION 1.3.5
------------------------

NEW FEATURES
    o Added GRangesFilter enabling filtering using a (single!) GRanges object.
    o Better usability and compatibility with chromosome names: SeqnameFilter and
      GRangesFilter support both Ensembl and UCSC chromosome names, if option
      ucscChromosomeNames is set to TRUE returned chromosome/seqnames are in
      UCSC format.

SIGNIFICANT USER-VISIBLE CHANGES
    o Added method "value" for BasicFilter objects.

BUG FIXES
    o transcripts, genes, exons return now results sorted
      by seq name and start coordinate.


CHANGES IN VERSION 1.3.4
------------------------

NEW FEATURES
    o Added extractTranscriptSeqs method for EnsDb objects.


SIGNIFICANT USER-VISIBLE CHANGES
    o Added a section to the vignette describing the use of ensembldb in Gviz.
    o Fixed the vignette to conform the "Bioconductor style".
    o Added argument use.names to exonsBy.

BUG FIXES
    o Fixed bug with getGeneRegionTrackForGviz with only chromosome specified.
    o Fixed an internal problem subsetting a seqinfo.


CHANGES IN VERSION 1.3.3
------------------------

NEW FEATURES
    o Add method getGeneRegionTrackForGviz to enable using EnsDb databases for Gviz.

BUG FIXES
    o cdsBy, fiveUTRsForTranscript and threeUTRsForTranscript do no longer throw
      an error if nothing was found but return NULL and produce a warning.



CHANGES IN VERSION 1.3.2
------------------------

NEW FEATURES
    o Implemented methods cdsBy, fiveUTRsForTranscript and threeUTRsForTranscript
      for EnsDb.



CHANGES IN VERSION 1.3.1
------------------------

BUG FIXES
    o Ensuring that methods exons, genes and transcripts return columns in the
      same order than provided with argument 'columns' for return.type 'data.frame'
      or 'DataFrame'.



CHANGES IN VERSION 1.1.9
------------------------

BUG FIXES

    o Fixed a figure placement problem that can result in an error on certain
      systems using a recent TexLive distribution.



CHANGES IN VERSION 1.1.6
------------------------

BUG FIXES

    o Fix a bug in lengthOf that caused an error if no filter was supplied.


CHANGES IN VERSION 1.1.5
------------------------

NEW FEATURES

    o Implemented a shiny web app to search for genes/transcripts/exons using
      annotation of an EnsDb annotation package (function runEnsDbApp).



CHANGES IN VERSION 1.1.4
------------------------

NEW FEATURES

    o Added promoters method.



CHANGES IN VERSION 1.1.3
------------------------

SIGNIFICANT USER-VISIBLE CHANGES

    o Added method ensemblVersion that returns the Ensembl version the package bases on.
    o Added method getGenomeFaFile that queries AnnotationHub to retrieve the Genome
      FaFile matching the Ensembl version of the EnsDb object.


CHANGES IN VERSION 1.1.2
------------------------

SIGNIFICANT USER-VISIBLE CHANGES

    o Added examples to the vignette for building an EnsDb using AnnotationHub along with
      the matching genomic sequence.
    o Added an example for fetching the sequences of genes, transcripts and exons to the vignette.


BUG FIXES

    o Fixed a bug in ensDbFromGRanges and ensDbFromGtf in which the genome build version
      was not set even if provided.



CHANGES IN VERSION 1.1.1
------------------------

SIGNIFICANT USER-VISIBLE CHANGES

    o The filter argument in all functions supports now also submission of a filter
      object, not only of a list of filter objects.



CHANGES IN VERSION 0.99.18
--------------------------

BUG FIXES

    o Fixed a problem in processing GTF files without header information.

    o Fixed a bug failing to throw an error if not all required feature types are
      available in the GTF.



CHANGES IN VERSION 0.99.17
--------------------------

NEW FEATURES

    o Added new function ensDbFromGRanges that builds an EnsDB database from information
      provided in a GRanges object (e.g. retrieved from the AnnotationHub).



CHANGES IN VERSION 0.99.16
--------------------------

SIGNIFICANT USER-VISIBLE CHANGES

    o Added argument outfile to ensDbFromGtf that allows to manually specify the file
      name of the database file.

    o ensDbFromGtf tries now to automatically fetch the sequence lengths from Ensembl.


BUG FIXES

    o Fixed the function that extracts the genome build version from the gtf file name.



CHANGES IN VERSION 0.99.15
--------------------------

NEW FEATURES

    o metadata method to extract the information from the metadata database table.

    o ensDbFromGtf function to generate a EnsDb SQLite file from an (Ensembl)
      GTF file.



CHANGES IN VERSION 0.99.14
--------------------------

BUG FIXES

    o Fixed a problem when reading tables fetched from Ensembl that contained ' or #.



CHANGES IN VERSION 0.99.13
--------------------------

SIGNIFICANT USER-VISIBLE CHANGES

    o Added argument "port" to the fetchTablesFromEnsembl to allow specifying the MySQL port
      of the database.



CHANGES IN VERSION 0.99.12
--------------------------

BUG FIXES

    o argument "x" for method organism changed to "object".


